/**
 * 版权所有 ©2021 
 * 工程名：yearBooks
 * 文件名：NcjjZczDao.java
 * 创建日期：2021年10月21日 上午9:19:04
 * 作者：duanxiaomingzi
 */
package com.lion.dao;

import java.util.List;
import java.util.Map;

import javax.annotation.Resource;

import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Repository;

import com.lion.entity.NcjjSy;

import jodd.util.StringUtil;

/**
 * 类描述 集体经济收益
 * @author duanxiaomingzi
 * @since 2021年10月21日
 */
@Repository
public class NcjjSyDao {
	@Resource
	private JdbcTemplate jdbc;
	public int add(NcjjSy z){
		String sql="insert into ncjj_sy (orgid,year,sr,zc,fz,createTime,createUser) values (?,?,?,?,?,?,?)";
		return jdbc.update(sql,z.getOrgid(),z.getYear(),z.getSr(),z.getZc(),z.getFz()
				,z.getCreateTime(),z.getCreateUser());
	}
	public int update(NcjjSy z){
		String sql="update ncjj_sy set year=?,sr=?,zc=?,fz=?,updateTime=?,updateUser=? where id=?";
		return jdbc.update(sql,z.getYear(),z.getSr(),z.getZc(),z.getFz(),z.getUpdateTime(),z.getUpdateUser()
				,z.getId());
	}
	public int delete(int id){
		String sql="delete from ncjj_sy where id=?";
		return jdbc.update(sql,id);
	}
	/**
	 * 方法描述 校验当前年度该单位是否已经录入过数据
	 * @author duanxiaomingzi
	 * @since 2021年10月21日
	 * @param z
	 * @return	
	 */
	public int checkIfExistByYearAndOrg(NcjjSy z){
		String sql="select count(id) from ncjj_sy where year=? and orgid=?";
		if(StringUtil.isNotEmpty(z.getId())){
			sql+=" and id<>"+z.getId();
		}
		return jdbc.queryForObject(sql,new Object[]{z.getYear(),z.getOrgid()}, Integer.class);
	}
	/**
	 * 方法描述 根据部门id查询数据
	 * @author duanxiaomingzi
	 * @since 2021年10月21日
	 * @param year 年度
	 * @param orgid 部门id
	 * @return	
	 */
	public List<Map<String,Object>> getList(String year,String orgid,int start,int limit){
		String sql="select z.*,o.name orgname from ncjj_sy z left join orgdept o on z.orgid=o.id where orgid like ?";
		if(StringUtil.isNotEmpty(year)){
			sql+=" and year="+year;
		}
		sql+=" order by year desc limit ?,?";
		return jdbc.queryForList(sql,orgid+"%",start,limit);
	}
	/**
	 * 方法描述 获取数量
	 * @author duanxiaomingzi
	 * @since 2021年10月21日
	 * @param year 年度
	 * @param orgid 部门id
	 * @return	
	 */
	public int getListCount(String year,String orgid){
		String sql="select count(id) from ncjj_sy where orgid like ?";
		if(StringUtil.isNotEmpty(year)){
			sql+=" and year="+year;
		}
		return jdbc.queryForObject(sql,new Object[]{orgid+"%"},Integer.class);
	}
}
